#include "TOP.h"
#include "tlm.h"

#include "Initiator.h"
#include "Target.h"
#include "Router.h"

// constructor
TOP::TOP( sc_module_name name )
    : sc_module( name )
    , targetNum( 4 ) // <== setting
{
    sc_assert( 0<targetNum && targetNum<TARGET_MAX );

    // instances
    initiator = new Initiator( "initiator" );
    router = new Router( "router", targetNum );

    for (unsigned int i=0; i<targetNum; i++) {
        char t_name[20];
        sprintf( t_name, "target_%d",  i );
        target[i] = new Target( t_name );
    }

    // binding
    initiator->i_socket.bind( router->t_socket );
    for (unsigned int i=0; i<targetNum; i++)
        router->i_socket[i]->bind( target[i]->t_socket );
}

// destructor
TOP::~TOP()
{
    delete initiator;
    delete router;
    for (unsigned int i=0; i<targetNum; i++) {
        delete target[i];
    }
}


